Index: /GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsToneMapDemo/include/GameToolsToneMapDemo.h
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsToneMapDemo/include/GameToolsToneMapDemo.h	(revision 2301)
+++ /GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsToneMapDemo/include/GameToolsToneMapDemo.h	(revision 2395)
@@ -80,8 +80,8 @@
 	void createPostproc()
 	{		
-		CompositorManager::getSingleton().addCompositor(mWindow->getViewport(0),
+		/*CompositorManager::getSingleton().addCompositor(mWindow->getViewport(0),
 														"GTP/PostProc/Glow");
 		CompositorManager::getSingleton().setCompositorEnabled(mWindow->getViewport(0),
-														"GTP/PostProc/Glow", true);
+														"GTP/PostProc/Glow", true);*/
 
 		CompositorManager::getSingleton().addCompositor(mWindow->getViewport(0),
Index: /GTP/trunk/App/Demos/Illum/Ogre/src/Moria/include/Moria.h
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/src/Moria/include/Moria.h	(revision 2391)
+++ /GTP/trunk/App/Demos/Illum/Ogre/src/Moria/include/Moria.h	(revision 2395)
@@ -159,8 +159,14 @@
 	{		
 		CompositorManager::getSingleton().addCompositor(mWindow->getViewport(0),
+														"GTP/Moria/PostProc/DoF");
+		CompositorManager::getSingleton().setCompositorEnabled(mWindow->getViewport(0),
+														"GTP/Moria/PostProc/DoF", true);
+
+	CompositorManager::getSingleton().addCompositor(mWindow->getViewport(0),
 														"GTP/PostProc/Glow");
 		CompositorManager::getSingleton().setCompositorEnabled(mWindow->getViewport(0),
 														"GTP/PostProc/Glow", true);
 
+		
 		CompositorManager::getSingleton().addCompositor(mWindow->getViewport(0),
 														"GTP/PostProc/ToneMap");
@@ -168,8 +174,9 @@
 														"GTP/PostProc/ToneMap", true);	
 
-	/*	CompositorManager::getSingleton().addCompositor(mWindow->getViewport(0),
-														"GTP/PostProc/Plain");
+		/*
+		CompositorManager::getSingleton().addCompositor(mWindow->getViewport(0),
+														"GTP/PostProc/MotionBlur");
 		CompositorManager::getSingleton().setCompositorEnabled(mWindow->getViewport(0),
-														"GTP/PostProc/Plain", true);	*/
+														"GTP/PostProc/MotionBlur", true);	*/
 		
 	}
@@ -214,5 +221,6 @@
 		DataStreamPtr inputStream; 				
 		inputStream = ResourceGroupManager::getSingleton().openResource("moria.level");	//towers2.level	
-		World* NXWorld = new World("FrameListener: yes, log: html");
+		World* NXWorld = new World("FrameListener: no, log: html");
+		NXWorld->getPhysXDriver()->createFrameListener(25);
 		NXScene = NXWorld->createScene("Main", mSceneMgr, "gravity: yes, floor: no"); 
 		s.setScene(NXScene);
@@ -258,9 +266,9 @@
 		
 		mainLightNode->setPosition(15,5,15);		
-		mainLight->setPowerScale(20);
+		mainLight->setPowerScale(100);
 		//mainLight->setDirection(1,0, 0);
 		mainLightNode->attachObject(mainLight);
 		//mainLight->setSpotlightRange(Degree(0),Degree(120));
-		mainLight->setAttenuation(1000.0, 0, 8, 0);
+		mainLight->setAttenuation(200.0, 0, 0, 2);
 /*
 		Light* blueLight = mSceneMgr->createLight("blueLight");
@@ -291,27 +299,28 @@
             mAnimState->setEnabled(true);
 
-		gFPSPlayer = new FPSPlayer(NXScene, mSceneMgr, Vector3(0.1, 0.6, 0.1), Vector3(5, 10, 5), 0.5, mCamera);
-		gFPSPlayer->addPlayerMesh("FPSarm.mesh", 0.005, true);
+		gFPSPlayer = new FPSPlayer(NXScene, mSceneMgr, Vector3(0.5, 1.8, 0.3), Vector3(15, 1, 15), 1.6, mCamera, false);
+		gFPSPlayer->addPlayerMesh("FPSarm.mesh", 0.02, true);
 		gFPSPlayer->addWeaponModel("sword.mesh", "joint28");
 
-		for(float i = 0; i< 10; i++)
+		for(float i = 0; i< 7; i++)
 		{
+			float size = 0.5;
 			ActorParams ac;
 			ac.setToDefault();
-			ac.mass = 10.0;
-			ac.nodescale = 1.0;
-			NXScene->createBody("cube.mesh",
-								new CubeShape(1, 1, 1),
-								Vector3(3,i,3),
+			ac.mass = 1.0;
+			ac.nodescale = size;
+			Body* b = NXScene->createBody("cube.mesh",
+								new CubeShape(size, size, size),
+								Vector3(3,size/2.0 + size * (i + 0.01),3),
 								ac);
+			b->setCharacterCollisionGroup(NX_CHARACTER_COL_GROUP_PUSHABLE);
 		}
-		
-/*
-	   ParticleSystem* pSys1 = mSceneMgr->createParticleSystem("psys1", "MoriaDust");
+	
+	  /* ParticleSystem* pSys1 = mSceneMgr->createParticleSystem("psys1", "MoriaDust");
 	   pSys1->setKeepParticlesInLocalSpace(true);
 	   pSysNode = rootNode->createChildSceneNode("psys1");
 	   pSysNode->attachObject(pSys1);
-	   pSysNode->setPosition(0,0,0);
-*/
+	   pSysNode->setPosition(0,0,0);*/
+
 
 		OgreIlluminationManager::getSingleton().initTechniques();
@@ -343,9 +352,9 @@
 		mFrameListener= new MoriaDemoFrameListener(mWindow,
 			mCamera, mainLightNode, mainLight, pSysNode	);
-        mFrameListener->setPriority(2);	
+        mFrameListener->setPriority(10);	
 		mRoot->addFrameListener(mFrameListener);
-		gFPSPlayer->setPriority(3);
+		gFPSPlayer->setPriority(20);
 	    mRoot->addFrameListener(gFPSPlayer);
-		OgreIlluminationManager::getSingleton().setPriority(4);
+		OgreIlluminationManager::getSingleton().setPriority(30);
 	    mRoot->addFrameListener(&OgreIlluminationManager::getSingleton());
 	  